import subprocess, sys

def ping( id ):
    """Ping a probe.
    Return False if it fails to respond, True otherwise"""
    p = subprocess.Popen( args = "probeping %i" % id,
                          shell = True, stdout = sys.stdout, stderr = sys.stderr )
    r = p.wait()
    if r == 0:
        return True
    else:
        return False

def getdata( id ):
    """Get the logged data from a probe.
    Currently doesn't return a value."""
    p = subprocess.Popen( args = "probegetdata %i" % id,
                          shell = True, stdout = sys.stdout, stderr = sys.stderr )
    p.wait()

def sleep( id ):
    """Send a probe to sleep.
    No return value -- since a probe doesn't ack sleep packets"""
    p = subprocess.Popen( args = "probesleep %i" % id,
                          shell = True, stdout = sys.stdout, stderr = sys.stderr )
    p.wait()
